$Embed:'source/default.png','defaultImg'

$Console
_Console Off
_ScreenHide

_Title "Volume Control - Book Player"

Type WaveHeaderType
    RiffID As String * 4 'should be 'RIFF'
    RiffLength As _Unsigned Long
    'rept. chunk id and size then chunk data
    WavID As String * 4 'should be 'WAVE'
    FmtID As String * 4
    FmtLength As Long
    'FMT ' chunk - common fields
    wavformattag As Integer ' word - format category e.g. 0x0001=PCM
    Channels As Integer ' word - number of Channels 1=mono 2=stereo
    SamplesPerSec As Long 'dword - sampling rate e.g. 44100Hz
    avgBytesPerSec As Long 'dword - to estimate buffer size
    blockalign As Integer ' word - buffer size must be int. multiple of this
    FmtSpecific As Integer ' word
    DataID As String * 4
    DataLength As _Unsigned Long
End Type

Type BMXHeaderType
    id As String * 3
    ver As _Unsigned _Byte
    Bits As _Unsigned _Byte
    VeraReg As _Unsigned _Byte
    Width As Integer
    Height As Integer
    PalUsed As _Unsigned _Byte
    PalStart As _Unsigned _Byte
    DataStart As _Unsigned Integer
    Compressed As _Byte
    VERABorder As _Unsigned _Byte
    Reserved As String * 16
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type


Rem This program uses more Global variables then is ideal
Rem However this is mostly because I ported a lot of logic
Rem from the Commander X16 version of this program where
Rem Global variables to pass information were my only
Rem Option.

Common Shared Slash$
Common Shared Title$
Common Shared Author$
Common Shared SubTitle$
Common Shared dialog$
Common Shared YEAR$
Common Shared PLAYFILE$
Common Shared BOOKFILE$
Common Shared FSecs$
Common Shared FMins$
Common Shared FHours$
Common Shared PSecs$
Common Shared PMins$
Common Shared PHours$
Common Shared CHAPTER
Common Shared CHAPTERS
Common Shared UserQuit%
Common Shared InTextMode%
Common Shared GotBookMark%
Common Shared MeterFG%
Common Shared MeterBG%
Common Shared MyFont&
Common Shared ArtIsLoaded%
Common Shared NewLoad%
Common Shared Got_Single%
Common Shared IN_INTRO%
Common Shared IN_EPILOGUE%
Common Shared BookStartUp%
Common Shared MyAudio_PlayLength#
Common Shared VERA_PlayLength#
Common Shared MyAudio&
Common Shared paused%
Common Shared SeekTimer#
Common Shared TimerMark$
Common Shared Got_BookMark%
Common Shared AudioExt$

Common Shared User_WantsExit%


ReDim Shared ImageData(0) As _Unsigned _Byte

Dim Shared DChars%(10)
Dim Shared WaveHeader As WaveHeaderType

Dim Shared Fcount
Dim Shared wid
Dim Shared hei
Dim Shared BadFile
Dim Shared InShow
Dim Shared BookArt&, Show2&
Dim Shared BMXName$
Dim Shared VERAPAL(0 To 255) As VPALTYPE
Dim Shared RGBPAL(0 To 255) As Long



Slash$ = "/"
$If WINDOWS Then
    Slash$ = "\"
$End If

Const BLACK = 0
Const VGA_BLUE = 1
Const VGA_GREEN = 2
Const VGA_CYAN = 3
Const VGA_RED = 4
Const VGA_MAGENTA = 5
Const VGA_BLACK2 = 5
Const VGA_ORANGE = 6
Const VGA_MEDGRAY = 7
Const VGA_DARKGRAY = 8
Const VGA_LITEBLUE = 9
Const VGA_LITEGREEN = 10
Const VGA_LITECYAN = 11
Const VGA_LITERED = 12
Const VGA_LITEMAGENTA = 13
Const VGA_YELLOW = 14
Const VGA_WHITE = 15

dcharacters:
Data &hC9,&hCD,&hBB,&hBA,&hBA,&hC8,&hCD,&hBC

AudioExt$ = ".WAV"
MyRoot$ = _CWD$
ChDir _StartDir$

If Right$(MyRoot$, 1) <> Slash$ Then MyRoot$ = MyRoot$ + Slash$

dialog$ = "vcdialog"
$If WINDOWS Then
    dialog$ = dialog$ + ".exe"
$End If

dialog$ = MyRoot$ + dialog$ + Chr$(32) + Chr$(34) + "Book Player" + Chr$(34) + Chr$(32) + Chr$(34) + "F1 - Toggles Text/Graphics" + Chr$(34) + " INFO"
BadCommandLine = 0

GetTheBookFolder:
If (_CommandCount = 0) Or BadCommandLine Then
    _ScreenHide
    If BadCommandLine Then GoTo GETCHOICE
    RETRYGETBOOK:
    TargetBookFolder$ = _SelectFolderDialog$("Select Book Folder", _StartDir$)
    If TargetBookFolder$ = "" Then System
    If Is_ABook_Folder(TargetBookFolder$) Then GoTo PROCEED
    L = Len(TargetBookFolder$)
    R = 0
    For I = L To 1 Step -1
        If Mid$(TargetBookFolder$, I, 1) = Slash$ Then
            R = I
            Exit For
        End If
    Next I
    GETCHOICE:
    CHOICE = _MessageBox("Not a Book Folder", Mid$(TargetBookFolder$, R + 1) + " is not a valid" + Chr$(13) + "Volume Control Book." + Chr$(13) + Chr$(13) + "Try Again?", "yesno", "warning", 1)
    If CHOICE = 1 Then GoTo RETRYGETBOOK
    System
End If


TargetBookFolder$ = Command$(1)

If Not Is_ABook_Folder(TargetBookFolder$) Then
    BadCommandLine = -1
    GoTo GetTheBookFolder
End If

PROCEED:
_ScreenShow
If _FileExists("VCONTROL.TTF") Then
    MyFont& = _LoadFont("VCONTROL.TTF", 16, "MONOSPACE")
End If
If MyFont& = 0 Then MyFont& = 17


LoadDChars

x = _Exit
User_WantsExit% = 0
On Timer(.75) GoSub CheckExits
Timer On

SETText
ChDir TargetBookFolder$
LOADBOOK

PlayBook
System

CheckExits:
If _Exit > 0 Then User_WantsExit% = -1
Return

Sub PlayBook ()
    InfoOn% = 0
    CHAPTER = 0
    INFORMATION_BOX
    SHOW_ControlBar
    BookStartUp% = -1
    CheckForArt
    Shell _DontWait _Hide dialog$


    CheckBookMark
    If Got_BookMark% Then
        If TimerMark$ = "EPILOGUE" Then GoTo DoEpilogue
        If TimerMark$ = "SINGLE" Then GoTo PlaySingleBook
        If Val(TimerMark$) > 0 Then
            CHAPTER = Val(TimerMark$)
            GoTo DoChapters
        End If
    End If

    If _FileExists("INTRO" + AudioExt$) Then Play_Intro
    If Got_Single% Then GoTo PlaySingleBook

    DoChapters:
    Do
        If Not Got_BookMark% Then CHAPTER = CHAPTER + 1
        PlayChapter
    Loop While CHAPTER < CHAPTERS And Not UserQuit%
    GoTo BOOK_WRAP

    PlaySingleBook:
    PLAYFILE$ = BOOKFILE$
    Play_THE_File

    BOOK_WRAP:
    If UserQuit% Then Exit Sub
    DoEpilogue:
    If _FileExists("EPILOGUE" + AudioExt$) Then Play_Epilogue
End Sub

Sub Play_Intro
    IN_INTRO% = -1
    PLAYFILE$ = "INTRO" + AudioExt$
    PrintChapter
    Play_THE_File
    IN_INTRO% = 0
End Sub

Sub Play_Epilogue
    IN_EPILOGUE% = -1
    PLAYFILE$ = "EPILOGUE" + AudioExt$
    PrintChapter
    Play_THE_File
    IN_EPILOGUE% = 0
End Sub

Sub PlayChapter ()
    n$ = Str$(CHAPTER)
    n$ = Right$(n$, Len(n$) - 1)
    POPDIR$ = _CWD$
    ChDir "CHAP" + n$
    PrintChapter
    CheckForArt
    PLAYFILE$ = "CHAP" + n$ + AudioExt$
    Play_THE_File
    ChDir POPDIR$
End Sub

Sub CheckForArt ()
    NewArt% = 0
    If _FileExists("ART.BMX") Then
        LoadArtImage
        ArtIsLoaded% = Not BadFile
        NewArt% = -1
    Else
        If BookStartUp% Then
            BookArt& = _LoadImage(_Embedded$("defaultImg"), 32, "memory")
            ArtIsLoaded% = -1
            NewArt% = -1
        End If
    End If

    If (Not InTextMode%) And NewArt% Then
        InTextMode% = -1
        SwapScreens
    ElseIf InTextMode% And NewArt% Then
        SwapScreens
        _Delay 1.2
        SwapScreens
    End If
    BookStartUp% = 0
End Sub


Sub Play_THE_File ()

    MeterFG% = VGA_DARKGRAY
    MeterBG% = VGA_BLACK2
    Dim C_Key As Long
    Dim SPos As Double
    GetWaveHeader (CheckWave(PLAYFILE$))
    MyAudio& = _SndOpen(CheckWave(PLAYFILE$), "STREAM")
    If MyAudio& = 0 Then
        _MessageBox "Audio Error", "Error Encountered Opening: " + PLAYFILE$, "error"
        System
    End If
    FSecs = _SndLen(MyAudio&)
    MyAudio_PlayLength# = FSecs

    FMins = Int(FSecs / 60)
    FSecs = _Round(FSecs - (FMins * 60))
    FHours = Int(FMins / 60)
    FMins = FMins - (FHours * 60)
    FHours$ = Mid$(Str$(FHours), 2)
    If FHours < 10 Then FHours$ = "0" + FHours$
    FMins$ = Mid$(Str$(FMins), 2)
    If FMins < 10 Then FMins$ = "0" + FMins$
    FSecs$ = Mid$(Str$(FSecs), 2)
    If FSecs < 10 Then FSecs$ = "0" + FSecs$
    PRINT_AUDIOLENGTH

    If Got_BookMark% Then
        SeekPos# = RealPosition(SeekTimer#)
        SeekPos# = SeekPos# / 60
        _SndSetPos MyAudio&, SeekPos#
        Got_BookMark% = 0
    End If


    PlayIsDone% = 0
    paused% = 0
    UserQuit% = 0
    VOLUME! = .75
    _SndVol MyAudio&, VOLUME!
    _SndPlay MyAudio&
    VTIMER! = 0
    GTIMER! = 0
    If Timer < 86300 Then
        BTIMER! = Timer + 90
    Else
        BTIMER! = 90 - (86399 - Timer)
    End If
    Do
        JustOn% = 0
        If VTIMER! > 0 Then
            If Timer < 86396 And Timer > VTIMER! Then
                Color VGA_WHITE, BLACK
                Locate 1, 29
                Print "         ";
                VTIMER! = 0
            End If
        End If

        C_Key = _KeyHit

        If (C_Key = 0) And _MouseInput Then
            If _MouseButton(1) Or _MouseButton(2) Or _MouseButton(3) Then
                C_Key = 1
            End If
        End If

        If C_Key > 0 Then
            If Not InTextMode% Then
                SwapScreens
                JustOn% = -1
            End If
            If Timer < 86300 Then
                BTIMER! = Timer + 90
            Else
                BTIMER! = 90 - (86399 - Timer)
            End If
        End If

        If (Timer < 86390) And (Timer > BTIMER!) And (Not Sflag) And (Not paused%) Then
            If InTextMode% Then SwapScreens
        End If

        If User_WantsExit% Then
            C_Key = 27
            User_WantsExit% = 0
        End If

        START_PROCESS_Keys:
        If C_Key = 27 Then
            If Not InTextMode% Then Sflag = -1: SwapScreens
            Ask2Quit
            PlayIsDone% = UserQuit%
            If PlayIsDone% Then
                WriteBookMark
                _SndStop MyAudio&
                GoTo endplayloop
            End If
            If Sflag Then SwapScreens: Sflag = 0
            FLAGGED = -1
        End If

        If C_Key = 32 Then
            If Not paused% Then
                If Not InTextMode% Then Sflag = -1: SwapScreens
                WriteBookMark
                _SndPause MyAudio&
                ShowPaused ("ON")
            Else
                _SndPlay MyAudio&
                ShowPaused ("OFF")
                If Sflag Then SwapScreens: Sflag = 0
            End If
            paused% = Not paused%
        End If

        If C_Key = 15104 Then
            If Not Sflag And (Not JustOn%) Then SwapScreens
        End If

        If C_Key = 19712 Then
            If _SndPlaying(MyAudio&) Then
                SPos# = _SndGetPos(MyAudio&)
                SPos# = SPos# + 5
                _SndSetPos MyAudio&, SPos#
                FLAGGED = -1
            End If
        End If

        If C_Key = 19200 Then
            If _SndPlaying(MyAudio&) Then
                SPos# = _SndGetPos(MyAudio&)
                SPos# = SPos# - 5
                If SPos < 0 Then SPos = 0
                _SndSetPos MyAudio&, SPos#
                FLAGGED = -1
            End If
        End If

        If C_Key = 20480 Then
            If VOLUME! >= .10 Then VOLUME! = VOLUME! - .05
            If VOLUME! < .10 And VOLUME! > .05 Then VOLUME! = .10
            _SndVol MyAudio&, VOLUME!
            If InTextMode% Then
                Locate 1, 29: Color VGA_GREEN, BLACK
                Print "VOL: ";
                Color VGA_YELLOW, BLACK
                T = 2
                Print Left$(_Trim$(Str$(VOLUME! * 100)), T) + "%   ";
                VTIMER! = Timer(.01) + 5
                If VTIMER! > 86400 Then VTIMER! = 5
            End If
        End If

        If C_Key = 18432 Then
            T = 2
            If VOLUME! < 1 Then VOLUME! = VOLUME! + .05
            If VOLUME! > 1 Then VOLUME! = 1
            If VOLUME! = 1 Then T = 3
            _SndVol MyAudio&, VOLUME!
            If InTextMode% Then
                Locate 1, 29: Color VGA_GREEN, BLACK
                Print "VOL: ";
                Color VGA_YELLOW, BLACK
                Print Left$(_Trim$(Str$(VOLUME! * 100)), T) + "%   ";
                VTIMER! = Timer(.01) + 5
                If VTIMER! > 86398 Then VTIMER! = 5
            End If
        End If

        If C_Key = 9 Then
            If Not Got_Single% And Not IN_EPILOGUE% And (CHAPTER < CHAPTERS) Then
                _SndStop MyAudio&
                paused% = 0
            End If
            If Not Got_Single% And Not IN_EPILOGUE% And (CHAPTER = CHAPTERS) Then
                C_Key = 27
                GoTo START_PROCESS_Keys
            End If
        End If

        If C_Key = -105 Or C_Key = -73 Then
            If (Not Got_Single%) And (CHAPTER <> 1) And Not (IN_EPILOGUE%) Then
                If CHAPTER < 1 Then CHAPTER = 0
                If CHAPTER > 1 Then CHAPTER = CHAPTER - 2
                _SndStop MyAudio&
                paused% = 0
            End If
        End If

        If Not _SndPlaying(MyAudio&) Then
            If Not paused% Then PlayIsDone% = -1
        End If
        endplayloop:


        If InTextMode% Then
            UpDateMeter

            If MeterTimer& = 0 Then
                MeterTimer& = Timer + 1
                If MeterTimer& > 86398 Then MeterTimer& = 1
                FLAGGED = -1
            End If

            If ((Timer > MeterTimer&) Or FLAGGED) And (Not paused%) Then
                PrintPosition
                FLAGGED = 0
                MeterTimer& = Timer + 1
                If MeterTimer& > 86398 Then MeterTimer& = 1
            End If
        End If

        _Limit 60
    Loop Until PlayIsDone%

    _SndClose MyAudio&
End Sub

Sub UpDateMeter ()
    Static MeterX%
    Static RowMeterTimer#

    If MeterX% = 0 Then MeterX% = 4

    If Not paused% And Timer > RowMeterTimer# Then
        Locate 25, MeterX%
        Color MeterFG%, MeterBG%
        Print Chr$(178);
        RowMeterTimer# = Timer + .1
        If RowMeterTimer# > 86399 Then RowMeterTimer# = .1
        MeterX% = MeterX% + 1
        If MeterX% = 38 Then
            MeterX% = 0
            Save = MeterBG%
            MeterBG% = MeterFG%
            If MeterBG% > 15 Then MeterBG% = MeterBG% - 16
            MeterFG% = Save
            If MeterBG% > 7 Then MeterFG% = MeterFG% + 16
        End If
    End If
End Sub

Sub PrintPosition ()
    PSecs = _SndGetPos(MyAudio&)
    PMins = Int(PSecs / 60)
    PSecs = _Round(PSecs - (PMins * 60))
    If PSecs = 60 Then PSecs = 59
    PHours = Int(PMins / 60)
    PMins = PMins - (PHours * 60)
    PHours$ = Mid$(Str$(PHours), 2)
    If PHours < 10 Then PHours$ = "0" + PHours$
    PMins$ = Mid$(Str$(PMins), 2)
    If PMins < 10 Then PMins$ = "0" + PMins$
    PSecs$ = Mid$(Str$(PSecs), 2)
    If PSecs < 10 Then PSecs$ = "0" + PSecs$
    Locate 22, 4
    Color VGA_LITEGREEN + 16, VGA_DARKGRAY
    Print "Position:  ";
    Color VGA_WHITE + 16
    Print PHours$;
    Color VGA_GREEN + 16
    Print ":";
    Color VGA_WHITE + 16
    Print PMins$;
    Color VGA_GREEN + 16
    Print ":";
    Color VGA_WHITE + 16
    Print PSecs$;
End Sub

Rem _SCREENX Not functional on Linux
Function ScX&
    $If WINDOWS Then
        ScX = _ScreenX
    $Else
        ScX = Int(_DesktopWidth / 6)
    $End If
End Function

Rem _SCREENY Not functional on Linux
Function ScY&
    $If WINDOWS Then
        ScY = _ScreenY
    $Else
        ScY = Int(_DesktopHeight / 4)
    $End If
End Function

Function CheckWave$ (WFILE$)
    If _FileExists(WFILE$) Then
        CheckWave = WFILE$
        Exit Function
    End If
    tmp1$ = Left$(WFILE$, Len(WFILE$) - 4)
    tmp2$ = Right$(WFILE$, 4)
    If _FileExists(tmp1$ + LCase$(tmp2$)) Then
        CheckWave = tmp1$ + LCase$(tmp2$)
        Exit Function
    End If
    If _FileExists(LCase$(tmp1$) + LCase$(tmp2$)) Then
        CheckWave = LCase$(tmp1$) + LCase$(tmp2$)
        Exit Function
    End If
    If _FileExists(UCase$(tmp1$) + UCase$(tmp2$)) Then
        CheckWave = UCase$(tmp1$) + UCase$(tmp2$)
        Exit Function
    End If
End Function

Sub FlushKeys
    Do
        X = _KeyHit
    Loop Until X = 0
End Sub

Sub ShowPaused (PSTA$)
    If Not InTextMode% Then Exit Sub
    Locate 25, 4
    Color VGA_WHITE, VGA_BLACK2
    If PSTA$ = "ON" Then
        Print "*";
        Color VGA_GREEN
        Print " PAUSED ";
        Color VGA_WHITE
        Print "*";
        PrintPosition
    End If
    If PSTA$ = "OFF" Then
        Color MeterFG%, MeterBG%
        Print rpt$(178, 10);
    End If
End Sub

Sub Ask2Quit ()
    UserQuit% = 0
    DO_QUIT% = 0
    Color VGA_RED, VGA_BLACK2
    TEXTBOX 11, 5, 9, 32
    Locate 14, 7: Print "QUIT ";
    Color VGA_GREEN
    L = Len(Title$)
    If L < 25 Then DTITLE$ = Title$
    If L > 24 And L < 27 Then DTITLE$ = Left$(Title$, 24)
    If L >= 27 Then DTITLE$ = Left$(Title$, 21) + "..."
    Print DTITLE$;
    Locate 16, 9
    Color VGA_MEDGRAY
    Print "(";
    Color VGA_LITEGREEN
    Print "Y";: Color VGA_YELLOW: Print "/";: Color VGA_LITEGREEN
    Print "N";: Color VGA_MEDGRAY: Print ")";
    Locate 12, 10
    GOTIT = 0
    Color VGA_WHITE + 16, VGA_DARKGRAY
    Locate 16, 14: Print " ";
    Color VGA_YELLOW + 16
    GETIT:
    _Limit 30
    PrintPosition
    UpDateMeter
    K& = _KeyHit
    X$ = ""
    If K& > 0 Then If K& < 255 Then X$ = Chr$(K&)
    If X$ = "" Then GoTo GETIT
    If X$ = "y" Then X$ = "Y"
    If X$ = "n" Then X$ = "N"
    If X$ = Chr$(27) Then GOTIT = TRUE: Q$ = "N": X$ = Chr$(13)
    If X$ <> "Y" And X$ <> "N" And X$ <> Chr$(13) Then BOING
    If X$ = "Y" Or X$ = "N" Then GOTIT = TRUE: Q$ = X$: Locate 16, 14: Print X$;
    If X$ <> Chr$(13) Then GoTo GETIT
    DO_QUIT% = (Q$ = "Y")
    UserQuit% = DO_QUIT%
    INFORMATION_BOX
    PRINT_AUDIOLENGTH
    SHOW_ControlBar
End Sub


Sub BOING
End Sub

Sub CheckBookMark ()
    Got_BookMark% = 0
    If _FileExists("BOOK.MARK") Then
        Open "BOOK.MARK" For Binary As #2
        TimerMark$ = GetCBMString(2)
        TimerMark$ = _Trim$(TimerMark$)
        tmp$ = GetCBMString(2)
        tmp$ = _Trim$(tmp$)
        Close 2
        If IsNum(tmp$) Then
            SeekTimer# = Val(tmp$) - 180
            If SeekTimer# < 0 Then SeekTimer# = 0
            Got_BookMark% = -1
        End If
    End If
End Sub

Sub GetWaveHeader (WaveFile$)
    If AudioExt$ <> ".WAV" Then Exit Sub
    tmp% = 0
    SUCCESS = 0
    If _FileExists(WaveFile$) Then
        Open WaveFile$ For Binary As 2
        Get #2, , WaveHeader
        Close 2
        tmp% = ((WaveHeader.RiffID = "RIFF") And (WaveHeader.WavID = "WAVE"))
        If tmp% Then tmp% = ((WaveHeader.FmtSpecific = 16) And (WaveHeader.Channels > 0) And (WaveHeader.Channels < 3) And (WaveHeader.wavformattag = 1))
    End If
    If tmp% Then
        WaveDataSize& = WaveHeader.RiffLength
        WAVE_Hz = WaveHeader.SamplesPerSec
        samples# = WAVE_Hz
        VERA_Byte = _Round((samples# / 48828.15) * 128)
        VERA_Hz# = (VERA_Byte / 128) * 48828.15
        VERA_BytesPerSecond& = _Round(VERA_Hz# * 2)
        If WaveHeader.Channels = 2 Then VERA_BytesPerSecond& = VERA_BytesPerSecond& * 2
        VERA_PlayLength# = _Round(WaveDataSize& / VERA_BytesPerSecond&)
    End If
End Sub

Sub SETText ()
    InTextMode% = -1
    Screen 0
    Rem  _ScreenMove S_x&, S_y&
    _Dest 0
    Width 40, 30
    _Font MyFont&
    _Blink Off
    _PaletteColor 5, _RGB32(16, 16, 30)
End Sub

Sub TEXTBOX (Y As Integer, X As Integer, H As Integer, W As Integer)
    Locate Y, X: Print Chr$(DChars%(1)); rpt$(DChars%(2), W - 2); Chr$(DChars%(3));
    If H = 2 Then GoTo SKIPMID
    BStart = Y + 1: BEnd = Y + (H - 2)
    For Y2 = BStart To BEnd: Locate Y2, X: Print Chr$(DChars%(4)); rpt$(32, W - 2); Chr$(DChars%(5));: Next
    SKIPMID:
    Locate Y + H - 1, X: Print Chr$(DChars%(6)); rpt$(DChars%(7), W - 2); Chr$(DChars%(8));
End Sub

Sub LoadDChars ()
    Restore dcharacters
    For I = 1 To 8
        Read DChars%(I)
    Next
End Sub

Function rpt$ (ChrCode As _Unsigned _Byte, length As _Unsigned _Byte)
    tmp$ = ""
    For I = 1 To length
        tmp$ = tmp$ + Chr$(ChrCode)
    Next
    rpt = tmp$
End Function

Function Is_ABook_Folder% (Target$)
    tmp% = 0
    Target$ = _Trim$(Target$)

    If _DirExists(Target$) Then
        Test$ = Target$
        If Right$(Test$, 1) <> Slash$ Then
            Test$ = Test$ + Slash$
        End If
        Test$ = Test$ + "BOOK.DESC"
        tmp% = _FileExists(Test$)
    End If
    Is_ABook_Folder = tmp%
End Function

Sub LOADBOOK ()
    Got_Single% = 0
    SUCCESS = 0
    Open "BOOK.DESC" For Binary As #5
    SubTitle$ = ""
    Title$ = GetCBMString$(5)
    Author$ = GetCBMString$(5)
    TMP$ = GetCBMString$(5)
    TMP$ = _Trim$(TMP$)
    If TMP$ <> "ENDDESC" Then YEAR$ = TMP$
    If TMP$ = "ENDDESC" Then GoTo READ_Chapter_Count
    TMP$ = GetCBMString$(5)
    TMP$ = _Trim$(TMP$)
    If TMP$ <> "ENDDESC" Then SubTitle$ = TMP$
    SUCCESS = TRUE
    READ_Chapter_Count:
    Close 5
    If _FileExists("BOOK.CHAPS") Then
        Open "BOOK.CHAPS" For Binary As #5
        S$ = GetCBMString$(5)
        S$ = _Trim$(S$)
        If S$ = "NONE" Then GoTo GOT_A_SINGLE
        CHAPTERS = Val(S$)
        If CHAPTERS = 0 Then CHAPTERS = -1
        Close 5
        Exit Sub
        GOT_A_SINGLE:
        Got_Single% = -1
        CHAPTERS = -2
        SINGLE_CHAPTER% = -1
        BOOKFILE$ = GetCBMString$(5)
        BOOKFILE$ = _Trim$(BOOKFILE$)
        PLAYFILE$ = BOOKFILE$
        DONE_LOAD_BOOK:
        Close 5
        Exit Sub
    End If
    COUNT_Chapters
End Sub

Sub COUNT_Chapters ()
    Count = 1
    CountDone% = 0
    Do
        n$ = Str$(Count)
        n$ = Right$(n$, Len(n$) - 1)
        chk$ = "CHAP" + n$ + Slash$ + "CHAP" + n$ + AudioExt$
        CountDone% = -1
        If _FileExists(chk$) Then
            CHAPTERS = Count
            Count = Count + 1
            CountDone% = 0
        End If
    Loop Until CountDone%
    Open "BOOK.CHAPS" For Binary As 1
    TMP$ = Str$(CHAPTERS) + Chr$(13)
    Put #1, , TMP$
    Close 1
End Sub

Sub INFORMATION_BOX ()
    If Not InTextMode% Then Exit Sub
    Color VGA_WHITE, BLACK
    If INFO_FLAGGED Then PrintChapter: Exit Sub
    Cls
    INFO_FLAGGED = -1
    Color VGA_ORANGE + 16, VGA_DARKGRAY
    TEXTBOX 4, 3, 24, 36
    WORKTITLE$ = Title$
    L = Len(WORKTITLE$)
    X = _Round((40 - L) / 2) + 1
    If X < 1 Then X = 1: Title$ = Left$(Title$, 40): L = 40
    Color VGA_LITEGREEN, VGA_BLACK2
    Locate 2, X: Print Title$;
    If L < 35 Then Color VGA_WHITE: Locate 2, X + L: Print " *";: Locate 2, X - 2: Print "* ";
    If L < 33 Then Locate 2, X - 3: Print "*";: Locate 2, X + L + 2: Print "*";


    Color VGA_LITEGREEN + 16, VGA.DARKGRAY
    Locate 6, 5: Print "Author: ";
    Color VGA_WHITE + 16: Print Author$;
    Y = 8
    If Len(SubTitle$) = 0 Then Y = 6: GoTo YEARPRINT
    Color VGA_LITEGREEN + 16, VGA_DARKGRAY
    Locate Y, 5: Print "Full Title: ";
    Color VGA_WHITE + 16
    If Len(SubTitle$) < 21 Then GoTo SUBTITLEPRINT
    GOT_COMMA = 0: X = 17
    For I = 1 To Len(SubTitle$)
        C$ = Mid$(SubTitle$, I, 1)
        Print C$;
        X = X + 1
        If (X > 29) And (C$ = Chr$(32) Or C$ = Chr$(9) Or GOT_COMMA) Then Y = Y + 1: X = 5: Locate Y, X
        GOT_COMMA = (C$ = ",")
    Next I

    GoTo YEARPRINT

    SUBTITLEPRINT:
    Print SubTitle$;
    YEARPRINT:
    Y = Y + 2
    Locate Y, 5
    Color VGA_LITEGREEN + 16: Print "Published: ";
    Color VGA_WHITE + 16: Print YEAR$;
    PrintChapter
    Color VGA_WHITE, VGA_BLACK2
    Locate 25, 4
    Print rpt$(32, 34);
    Locate 26, 4
    Print rpt$(32, 34);
    Locate 26, 4
    _ControlChr Off
    If Got_Single% Then GoTo SKIP_TABCONTROL
    Print "[";
    Color VGA_GREEN: Print "TAB";
    Color VGA_WHITE: Print "]-";
    Color VGA_RED
    Print "Chap";: Color VGA_LITEGREEN: Print Chr$(&H1A);
    Color VGA_WHITE: Print "(";
    Color VGA_MEDGRAY: Print "+";: Color VGA_MEDGRAY: Print "ctrl";
    Color VGA_LITEGREEN: Print Chr$(&H1B);
    Color VGA_WHITE: Print ")";
    SKIP_TABCONTROL:
    Locate 26, 26
    Color VGA_WHITE
    Print "[";
    Color VGA_GREEN: Print Chr$(&H1D);
    _ControlChr On
    Color VGA_WHITE: Print "]-";
    Color VGA_RED: Print "Fwd/Rev";
    PrintChapter
End Sub

Sub PrintChapter ()
    If Not InTextMode% Then Exit Sub
    Color VGA_LITEGREEN + 16, VGA_DARKGRAY
    For Y = 17 To 23: Locate Y, 4: Print rpt$(32, 34);: Next
    Locate 26, 4
    For Y = 18 To 23: Locate Y, 4: Print rpt$(32, 34);: Next
    Locate 20, 5
    Color VGA_LITEGREEN + 16
    If Got_Single% Or IN_INTRO% Or IN_EPILOGUE% Then GoTo SINGLEPRINT
    Print "Chapter: ";
    Color VGA_YELLOW + 16: Print CHAPTER;
    Color VGA_WHITE + 16: Print " of";: Color VGA_YELLOW + 16: Print CHAPTERS;
    GoTo END_INFO
    SINGLEPRINT:
    Print "Playing:  ";
    Color VGA_YELLOW + 16
    L = Len(PLAYFILE$)
    If IN_INTRO% Or IN_EPILOGUE% Then Print Left$(PLAYFILE$, L - 4): GoTo END_INFO
    Print BOOKFILE$;
    END_INFO:
    If _FileExists("CHAP.TITLE") Then
        Locate 17, 5
        ChTitle$ = GetChapTitle$
        L = Len(ChTitle$)
        Color VGA_YELLOW + 16
        If L < 34 Then
            Print ChTitle$;
            If L < 33 Then Print rpt$(32, 33 - L);
        End If
        If L < 34 Then Exit Sub
        LN$ = ChTitle$
        CXOS = 0
        For I = L To 1 Step -1
            C$ = Mid$(LN$, I, 1): C = Asc(C$)
            If C = 32 And I < 33 Then CXOS = I: I = 1
        Next
        If CXOS > 0 Then Print Left$(LN$, CXOS);: Locate 18, 5: TM$ = Right$(LN$, (L - CXOS)): Print Left$(TM$, 33);: If Len(TM$) < 33 Then Print rpt$(32, 33 - Len(TM$));
        If CXOS = 0 Then Print Left$(LN$, 33);
    End If
End Sub

Sub PRINT_AUDIOLENGTH ()
    Locate 21, 6
    Color VGA_LITEGREEN + 16, VGA_DARKGRAY
    Print "Length:  ";
    Color VGA_MEDGRAY + 16, VGA_DARKGRAY
    Print FHours$;
    Color VGA_GREEN + 16
    Print ":";
    Color VGA_MEDGRAY + 16, VGA_DARKGRAY
    Print FMins$;
    Color VGA_GREEN + 16
    Print ":";
    Color VGA_MEDGRAY + 16, VGA_DARKGRAY
    Print FSecs$;
End Sub


Sub SHOW_ControlBar ()
    If Not InTextMode% Then Exit Sub
    Color VGA_WHITE, VGA_BLACK2
    Locate 29, 1
    Print rpt$(32, 40);
    Locate 30, 1
    Print rpt$(32, 40);
    Locate 30, 2
    Print "[";
    Color VGA_LITEGREEN
    Print "ESC";
    Color VGA_WHITE
    Print "]-";
    Color VGA_LITERED: Print "Exit";
    Locate 30, 14
    Color VGA_WHITE
    Print "[";
    Color VGA_LITEGREEN
    Print "SPACE";
    Color VGA_WHITE
    Print "]-";
    Color VGA_LITERED: Print "Pause";
    Locate 30, 29
    Color VGA_WHITE
    Print "[";
    Color VGA_LITEGREEN
    _ControlChr Off
    Print Chr$(&H18); Chr$(&H19);
    _ControlChr On
    Color VGA_WHITE: Print "]-";
    Color VGA_LITERED: Print "Volume";
    Locate 29, 3
    Color VGA_WHITE
    Print "[";
    Color VGA_LITEGREEN
    Print "F1";
    Color VGA_WHITE
    Print "]-";
    Color VGA_LITERED: Print "Hide Text Info";
End Sub


Function GetChapTitle$ ()
    Open "CHAP.TITLE" For Binary As 1
    If LOF(1) < 3 Then
        GetChapTitle = ""
        Close 1
        Kill "CHAP.TITLE"
        Exit Function
    End If
    GetChapTitle$ = GetCBMString$(1)
    Close 1
End Function


Function GetCBMString$ (LFN%)
    Dim B As _Unsigned _Byte
    TMP$ = ""
    Do
        Get #LFN%, , B
        If B <> 13 And B <> 10 Then TMP$ = TMP$ + Chr$(B)
    Loop Until B = 13 Or B = 10
    GetCBMString$ = TMP$
End Function



Sub WriteBookMark ()
    AddDir$ = "../"
    If Got_Single% Or IN_INTRO% Or IN_EPILOGUE% Then AddDir$ = ""
    BFile$ = AddDir$ + "BOOK.MARK"
    If _FileExists(BFile$) Then Kill BFile$
    Open BFile$ For Binary As #2
    If IN_INTRO% Then HEAD$ = "INTRO": GoTo WRITETIMER
    If IN_EPILOGUE% Then HEAD$ = "EPILOGUE": GoTo WRITETIMER
    If Got_Single% Then HEAD$ = "SINGLE": GoTo WRITETIMER
    HEAD$ = Str$(CHAPTER)
    WRITETIMER:
    HEAD$ = HEAD$ + Chr$(13)
    Put #2, , HEAD$
    CurTime# = _SndGetPos(MyAudio&)
    CurTime# = VeraPosition(CurTime#)
    CurTime& = _Round(CurTime# * 59.97)
    TimeString$ = Str$(CurTime&) + Chr$(13)
    Put #2, , TimeString$
    Close 2
End Sub


Sub LoadArtImage ()
    If ArtIsLoaded% Then
        If InTextMode% Then
            _FreeImage BookArt&
        Else
            Rem _ScreenHide
            Screen 0
            _FreeImage BookArt&
        End If
    End If
    LoadBMX "ART.BMX"
    If BadFile Then
        If Not InTextMode% Then SETText
        ArtIsLoaded% = 0
        Exit Sub
    End If
    NewLoad = -1
    BookArt& = _NewImage(wid * 2, hei * 2, 32)
    Show2& = _NewImage(wid, hei, 32)
    _Dest Show2&
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), RGBPAL(ImageData(PixIndx&))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _Dest 0
    _PutImage , Show2&, BookArt&
    _FreeImage Show2&
    ArtIsLoaded% = -1
    If Not InTextMode% Then
        Screen BookArt&
        _ScreenShow
    End If
End Sub

Sub SwapScreens ()
    S_x& = ScX
    S_y& = ScY
    If InTextMode% Then
        If ArtIsLoaded% Then
            Rem _ScreenHide
            Screen BookArt&
            Rem _ScreenShow
            Rem _ScreenMove S_x&, S_y&
            InTextMode% = 0
        Else
            Exit Sub
        End If
    Else
        Rem _ScreenHide
        SETText
        INFORMATION_BOX
        PRINT_AUDIOLENGTH
        SHOW_ControlBar
        Rem _ScreenShow
        Rem _ScreenMove S_x&, S_y&
    End If
End Sub

Function VeraPosition& (RealPos#)
    VERA_Ratio# = VERA_PlayLength# / MyAudio_PlayLength#
    VeraPosition = _Round(RealPos# * VERA_Ratio#)
End Function

Function RealPosition& (VeraPos#)
    REAL_Ratio# = MyAudio_PlayLength# / VERA_PlayLength#
    RealPosition = _Round(VeraPos# * REAL_Ratio#)
End Function


Sub LoadBMX (ImgFile$)
    Dim BmxHeader As BMXHeaderType
    BadFile = 0
    If Not _FileExists(ImgFile$) Then
        BadFile = -1
        Exit Sub
    End If

    BMXName$ = GetFileName(ImgFile$) + GetFileExt(ImgFile$)
    Open ImgFile$ For Binary As #1

    Get #1, , BmxHeader
    If BmxHeader.id <> "BMX" Then
        _MessageBox "Not a BMX File", BMXName$ + " NOT A BMX FILE", "error"
        Close 1
        BadFile = -1
        Exit Sub
    End If
    If BmxHeader.ver <> 1 Then
        _MessageBox "Version: " + Str$(BmxHeader.ver), BMXName$ + " NOT SUPPORTED", "error"
        BadFile = -1
        Close 1
        Exit Sub
    End If
    If BmxHeader.Bits <> 8 Then
        _MessageBox "Bit Depth: " + Str$(BmxHeader.Bits), BMXName$ + " NOT SUPPORTED", "error"
        BadFile = -1
        Close 1
        Exit Sub
    End If
    If BmxHeader.Compressed <> 0 Then
        _MessageBox "Compression", BMXName$ + " NOT SUPPORTED", "error"
        BadFile = -1
        Close 1
        Exit Sub
    End If
    wid = BmxHeader.Width
    hei = BmxHeader.Height
    ImageSize& = wid * hei
    ReDim ImageData(0 To (ImageSize& - 1)) As _Unsigned _Byte
    If BmxHeader.PalUsed = 0 Then
        used = 256
    Else
        used = BmxHeader.PalUsed
    End If
    PALSize = used * 2
    PalEnd = (BmxHeader.PalStart + used) - 1
    ReDim PALDATA(BmxHeader.PalStart To PalEnd) As VPALTYPE
    Get #1, , PALDATA()
    For I = BmxHeader.PalStart To PalEnd
        VERAPAL(I) = PALDATA(I)
        RGBPAL(I) = VERA2RGB(VERAPAL(I))
    Next I

    Get #1, , ImageData()
    Close #1
End Sub

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function


Function GetFileExt$ (FName$)
    DOT$ = "."
    L = Len(FName$)
    TMP$ = ""
    If InStr(1, FName$, DOT$) = 0 Then GoTo Skipall
    For I = L To 1 Step -1
        C$ = Mid$(FName$, I, 1)
        TMP$ = C$ + TMP$
        If C$ = DOT$ Then Exit For
    Next I
    Skipall:
    GetFileExt = TMP$
End Function

Function GetFileName$ (FName$)
    $If WINDOWS Then
        Slash$ = "\"
    $Else
        Slash$ = "/"
    $End If

    TMP$ = ""
    T$ = GetFileExt(FName$)
    CUT = Len(T$)
    L = Len(FName$)
    TName$ = Left$(FName$, L - CUT)
    If InStr(1, TName$, Slash$) = 0 Then
        TMP$ = TName$
        GoTo Skiploop
    End If
    For I = Len(TName$) To 1 Step -1
        C$ = Mid$(TName$, I, 1)
        If C$ <> Slash$ Then
            TMP$ = C$ + TMP$
        Else
            Exit For
        End If
    Next I
    Skiploop:
    GetFileName = TMP$
End Function

Function GetFilePath$ (FName$)
    t1$ = GetFileExt(FName$)
    t2$ = GetFileName(FName$)
    L = Len(FName$) - (Len(t1$) + Len(t2$))
    GetFilePath$ = Left$(FName$, L)
End Function

Function IsNum%% (PassedText As String)
    text$ = PassedText
    special$ = UCase$(Left$(text$, 2))
    Select Case special$
        Case "&H", "&B", "&O"
            'check for symbols on right side of value
            r3$ = Right$(text$, 3)
            Select Case r3$
                Case "~&&", "~%%", "~%&" 'unsigned int64, unsigned byte, unsigned offset
                    text$ = Left$(text$, Len(text$) - 3)
                Case Else
                    r2$ = Right$(text$, 2)
                    Select Case r2$
                        Case "~&", "##", "%&", "%%", "~%", "&&" 'unsigned long, float, offset, byte, unsigned integer, int64
                            text$ = Left$(text$, Len(text$) - 2)
                        Case Else
                            r$ = Right$(text$, 1)
                            Select Case r$
                                Case "&", "#", "%", "!" 'long, double, integer, single
                                    text$ = Left$(text$, Len(text$) - 1)
                            End Select
                    End Select
            End Select
            check$ = "0123456789ABCDEF"
            If special$ = "&O" Then check$ = "01234567"
            If special$ = "&B" Then check$ = "01"
            temp$ = Mid$(UCase$(text$), 2)
            For i = 1 To Len(temp$)
                If InStr(check$, Mid$(temp$, i, 1)) = 0 Then Exit For
            Next
            If i <= Len(temp$) Then IsNum = -1
        Case Else
            If _Trim$(Str$(Val(text$))) = text$ Then IsNum = -1
    End Select
End Function



