$Embed:'source/default.png','defaultImg'

$Console
_Console Off
_ScreenHide

_Title "Volume Control - Book Wizard"

Type WaveHeaderType
    RiffID As String * 4 'should be 'RIFF'
    RiffLength As _Unsigned Long
    'rept. chunk id and size then chunk data
    WavID As String * 4 'should be 'WAVE'
    FmtID As String * 4
    FmtLength As Long
    'FMT ' chunk - common fields
    wavformattag As Integer ' word - format category e.g. 0x0001=PCM
    Channels As Integer ' word - number of Channels 1=mono 2=stereo
    SamplesPerSec As Long 'dword - sampling rate e.g. 44100Hz
    avgBytesPerSec As Long 'dword - to estimate buffer size
    blockalign As Integer ' word - buffer size must be int. multiple of this
    FmtSpecific As Integer ' word
    DataID As String * 4
    DataLength As _Unsigned Long
End Type

Type BMXHeaderType
    id As String * 3
    ver As _Unsigned _Byte
    Bits As _Unsigned _Byte
    VeraReg As _Unsigned _Byte
    Width As Integer
    Height As Integer
    PalUsed As _Unsigned _Byte
    PalStart As _Unsigned _Byte
    DataStart As _Unsigned Integer
    Compressed As _Byte
    VERABorder As _Unsigned _Byte
    Reserved As String * 16
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type


Rem This program uses more Global variables then is ideal
Rem However this is mostly because I ported a lot of logic
Rem from the Commander X16 version of this program where
Rem Global variables to pass information were my only
Rem Option.

Common Shared Slash$
Common Shared Title$
Common Shared Author$
Common Shared SubTitle$
Common Shared dialog$
Common Shared YEAR$
Common Shared PLAYFILE$
Common Shared BOOKFILE$
Common Shared FSecs$
Common Shared FMins$
Common Shared FHours$
Common Shared PSecs$
Common Shared PMins$
Common Shared PHours$
Common Shared CHAPTER
Common Shared CHAPTERS
Common Shared UserQuit%
Common Shared InTextMode%
Common Shared GotBookMark%
Common Shared MeterFG%
Common Shared MeterBG%
Common Shared MyFont&
Common Shared ArtIsLoaded%
Common Shared NewLoad%
Common Shared Got_Single%
Common Shared IN_INTRO%
Common Shared IN_EPILOGUE%
Common Shared BookStartUp%
Common Shared MyAudio_PlayLength#
Common Shared VERA_PlayLength#
Common Shared MyAudio&
Common Shared paused%
Common Shared SeekTimer#
Common Shared TimerMark$
Common Shared Got_BookMark%
Common Shared AudioExt$

Common Shared User_WantsExit%


ReDim Shared ImageData(0) As _Unsigned _Byte

Dim Shared DChars%(10)
Dim Shared WaveHeader As WaveHeaderType
Dim Shared Fcount
Dim Shared wid
Dim Shared hei
Dim Shared BadFile
Dim Shared InShow
Dim Shared BookArt&, Show2&
Dim Shared BMXName$
Dim Shared VERAPAL(0 To 255) As VPALTYPE
Dim Shared RGBPAL(0 To 255) As Long



Slash$ = "/"
$If WINDOWS Then
    Slash$ = "\"
$End If

Const BLACK = 0
Const VGA_BLUE = 1
Const VGA_GREEN = 2
Const VGA_CYAN = 3
Const VGA_RED = 4
Const VGA_MAGENTA = 5
Const VGA_BLACK2 = 5
Const VGA_ORANGE = 6
Const VGA_MEDGRAY = 7
Const VGA_DARKGRAY = 8
Const VGA_LITEBLUE = 9
Const VGA_LITEGREEN = 10
Const VGA_LITECYAN = 11
Const VGA_LITERED = 12
Const VGA_LITEMAGENTA = 13
Const VGA_YELLOW = 14
Const VGA_WHITE = 15

dcharacters:
Data &hC9,&hCD,&hBB,&hBA,&hBA,&hC8,&hCD,&hBC

AudioExt$ = ".WAV"
MyRoot$ = _CWD$
ChDir _StartDir$

If Right$(MyRoot$, 1) <> Slash$ Then MyRoot$ = MyRoot$ + Slash$


_ScreenShow
If _FileExists("VCONTROL.TTF") Then
    MyFont& = _LoadFont("VCONTROL.TTF", 16, "MONOSPACE")
End If
If MyFont& = 0 Then MyFont& = 17
_Blink Off


LoadDChars
MainMenu
nd$ = _SelectFolderDialog$("Select NUKE Folder", _StartDir$)
NukeDir nd$

End


Sub MainMenu ()
    Screen 0
    _Font 17
    Width 40, 38
    Color 15, 0
    _PaletteColor 5, _RGB32(16, 16, 30)
    Cls
    Color BLACK, VGA_BLACK2
    For I = 1 To 37: Print rpt$(178, 40);: Next I
    Color VGA_ORANGE + 16, VGA_DARKGRAY
    TEXTBOX 4, 3, 23, 36
    View Print 30 To 38
    Color 15, VGA_BLACK2
    Cls
    View Print
    Locate 6, 6: Color VGA_WHITE + 16, VGA_DARKGRAY
    Print "[";: Color VGA_LITEGREEN + 16: Print "F1";
    Color VGA_WHITE + 16: Print "]";: Color VGA_YELLOW + 16: Print " - ";: Color VGA_WHITE + 16: Print "Readme";

    Locate 8, 6: Color VGA_WHITE + 16, VGA_DARKGRAY
    Print "[";: Color VGA_LITEGREEN + 16: Print "F2";
    Color VGA_WHITE + 16: Print "]";: Color VGA_YELLOW + 16: Print " - ";: Color VGA_WHITE + 16: Print "Create Monolithic Book";

    Locate 10, 6: Color VGA_WHITE + 16, VGA_DARKGRAY
    Print "[";: Color VGA_LITEGREEN + 16: Print "F2";
    Color VGA_WHITE + 16: Print "]";: Color VGA_YELLOW + 16: Print " - ";: Color VGA_WHITE + 16: Print "Create Chaptered Book";

    Locate 12, 6: Color VGA_WHITE + 16, VGA_DARKGRAY
    Print "[";: Color VGA_LITEGREEN + 16: Print "F3";
    Color VGA_WHITE + 16: Print "]";: Color VGA_YELLOW + 16: Print " - ";: Color VGA_WHITE + 16: Print "Edit an Existing Book";

    Locate 14, 6: Color VGA_WHITE + 16, VGA_DARKGRAY
    Print "[";: Color VGA_LITEGREEN + 16: Print "F4";
    Color VGA_WHITE + 16: Print "]";: Color VGA_YELLOW + 16: Print " - ";: Color VGA_WHITE + 16: Print "Remove an Existing Book";


    Color VGA_GREEN, VGA_BLACK2
    Locate 31, 2: Print "Working Directory";
    Color VGA_LITEGREEN
    Locate 32, 2: Print "-----------------";
    Color VGA_YELLOW
    Locate 33, 2: Print _CWD$;
End Sub







Sub NukeDir (TheDir$)
    If Not _DirExists(TheDir$) Then Exit Sub
    POPDIR$ = _CWD$
    ChDir TheDir$
    FC = 0
    X$ = _Files$("*")
    Do While X$ <> ""
        If X$ <> "." + Slash$ And X$ <> ".." + Slash$ Then
            FC = FC + 1
        End If
        X$ = _Files$
    Loop
    ReDim DaList$(FC + 1)
    FC = 1
    X$ = _Files$("*")
    Do While X$ <> ""
        If X$ <> "." + Slash$ And X$ <> ".." + Slash$ Then
            DaList$(FC) = X$
            FC = FC + 1
        End If
        X$ = _Files$
    Loop

    For FLIST = 1 To FC - 1
        Dir$ = DaList$(FLIST)
        Color VGA_YELLOW, VGA_BLACK2

        Locate 28, 1: Print rpt$(32, 40);: Locate 28, 1
        If Right$(Dir$, 1) = Slash$ Then
            Print "RD: "; Dir$;
            NukeDir Dir$
        Else
            Print "Kill: "; Dir$;
            Kill Dir$
        End If
    Next FLIST

    ChDir POPDIR$
    RmDir TheDir$
End Sub





Sub dodialog
    dialog$ = "vdialog"
    $If WINDOWS Then
        dialog$ = dialog$ + ".exe"
    $End If

    dialog$ = MyRoot$ + dialog$ + Chr$(32) + Chr$(34) + "Book Player" + Chr$(34) + Chr$(32) + Chr$(34) + "F1 - Toggles Text/Graphics" + Chr$(34) + " INFO"
End Sub


Sub FlushKeys
    Do
        X = _KeyHit
    Loop Until X = 0
End Sub


Sub Ask2Quit ()
    UserQuit% = 0
    DO_QUIT% = 0
    Color VGA_RED, VGA_BLACK2
    TEXTBOX 11, 5, 9, 32
    Locate 14, 7: Print "QUIT ";
    Color VGA_GREEN
    L = Len(Title$)
    If L < 25 Then DTITLE$ = Title$
    If L > 24 And L < 27 Then DTITLE$ = Left$(Title$, 24)
    If L >= 27 Then DTITLE$ = Left$(Title$, 21) + "..."
    Print DTITLE$;
    Locate 16, 9
    Color VGA_MEDGRAY
    Print "(";
    Color VGA_LITEGREEN
    Print "Y";: Color VGA_YELLOW: Print "/";: Color VGA_LITEGREEN
    Print "N";: Color VGA_MEDGRAY: Print ")";
    Locate 12, 10
    GOTIT = 0
    Color VGA_WHITE + 16, VGA_DARKGRAY
    Locate 16, 14: Print " ";
    Color VGA_YELLOW + 16
    GETIT:
    _Limit 30
    K& = _KeyHit
    X$ = ""
    If K& > 0 Then If K& < 255 Then X$ = Chr$(K&)
    If X$ = "" Then GoTo GETIT
    If X$ = "y" Then X$ = "Y"
    If X$ = "n" Then X$ = "N"
    If X$ = Chr$(27) Then GOTIT = TRUE: Q$ = "N": X$ = Chr$(13)
    If X$ <> "Y" And X$ <> "N" And X$ <> Chr$(13) Then BOING
    If X$ = "Y" Or X$ = "N" Then GOTIT = TRUE: Q$ = X$: Locate 16, 14: Print X$;
    If X$ <> Chr$(13) Then GoTo GETIT
    DO_QUIT% = (Q$ = "Y")
    UserQuit% = DO_QUIT%
    SHOW_ControlBar
End Sub


Sub BOING
End Sub


Sub GetWaveHeader (WaveFile$)
    If AudioExt$ <> ".WAV" Then Exit Sub
    tmp% = 0
    SUCCESS = 0
    If _FileExists(WaveFile$) Then
        Open WaveFile$ For Binary As 2
        Get #2, , WaveHeader
        Close 2
        tmp% = ((WaveHeader.RiffID = "RIFF") And (WaveHeader.WavID = "WAVE"))
        If tmp% Then tmp% = ((WaveHeader.FmtSpecific = 16) And (WaveHeader.Channels > 0) And (WaveHeader.Channels < 3) And (WaveHeader.wavformattag = 1))
    End If
    If tmp% Then
        WaveDataSize& = WaveHeader.RiffLength
        WAVE_Hz = WaveHeader.SamplesPerSec
        samples# = WAVE_Hz
        VERA_Byte = _Round((samples# / 48828.15) * 128)
        VERA_Hz# = (VERA_Byte / 128) * 48828.15
        VERA_BytesPerSecond& = _Round(VERA_Hz# * 2)
        If WaveHeader.Channels = 2 Then VERA_BytesPerSecond& = VERA_BytesPerSecond& * 2
        VERA_PlayLength# = _Round(WaveDataSize& / VERA_BytesPerSecond&)
    End If
End Sub

Sub SETText ()
    InTextMode% = -1
    Screen 0
    _Dest 0
    Width 40, 30
    _Font MyFont&
    _Blink Off
    _PaletteColor 5, _RGB32(16, 16, 30)
End Sub

Sub TEXTBOX (Y As Integer, X As Integer, H As Integer, W As Integer)
    Locate Y, X: Print Chr$(DChars%(1)); rpt$(DChars%(2), W - 2); Chr$(DChars%(3));
    If H = 2 Then GoTo SKIPMID
    BStart = Y + 1: BEnd = Y + (H - 2)
    For Y2 = BStart To BEnd: Locate Y2, X: Print Chr$(DChars%(4)); rpt$(32, W - 2); Chr$(DChars%(5));: Next
    SKIPMID:
    Locate Y + H - 1, X: Print Chr$(DChars%(6)); rpt$(DChars%(7), W - 2); Chr$(DChars%(8));
End Sub

Sub LoadDChars ()
    Restore dcharacters
    For I = 1 To 8
        Read DChars%(I)
    Next
End Sub

Function rpt$ (ChrCode As _Unsigned _Byte, length As _Unsigned _Byte)
    tmp$ = ""
    For I = 1 To length
        tmp$ = tmp$ + Chr$(ChrCode)
    Next
    rpt = tmp$
End Function



Sub SHOW_ControlBar ()
    If Not InTextMode% Then Exit Sub
    Color VGA_WHITE, VGA_BLACK2
    Locate 29, 1
    Print rpt$(32, 40);
    Locate 30, 1
    Print rpt$(32, 40);
    Locate 30, 2
    Print "[";
    Color VGA_LITEGREEN
    Print "ESC";
    Color VGA_WHITE
    Print "]-";
    Color VGA_LITERED: Print "Exit";
    Locate 30, 14
    Color VGA_WHITE
    Print "[";
    Color VGA_LITEGREEN
    Print "SPACE";
    Color VGA_WHITE
    Print "]-";
    Color VGA_LITERED: Print "Pause";
    Locate 30, 29
    Color VGA_WHITE
    Print "[";
    Color VGA_LITEGREEN
    _ControlChr Off
    Print Chr$(&H18); Chr$(&H19);
    _ControlChr On
    Color VGA_WHITE: Print "]-";
    Color VGA_LITERED: Print "Volume";
    Locate 29, 3
    Color VGA_WHITE
    Print "[";
    Color VGA_LITEGREEN
    Print "F1";
    Color VGA_WHITE
    Print "]-";
    Color VGA_LITERED: Print "Hide Text Info";
End Sub



Function GetCBMString$ (LFN%)
    Dim B As _Unsigned _Byte
    TMP$ = ""
    Do
        Get #LFN%, , B
        If B <> 13 And B <> 10 Then TMP$ = TMP$ + Chr$(B)
    Loop Until B = 13 Or B = 10
    GetCBMString$ = TMP$
End Function



Sub LoadArtImage ()
    If ArtIsLoaded% Then
        If InTextMode% Then
            _FreeImage BookArt&
        Else
            Rem _ScreenHide
            Screen 0
            _FreeImage BookArt&
        End If
    End If
    LoadBMX "ART.BMX"
    If BadFile Then
        If Not InTextMode% Then SETText
        ArtIsLoaded% = 0
        Exit Sub
    End If
    NewLoad = -1
    BookArt& = _NewImage(wid * 2, hei * 2, 32)
    Show2& = _NewImage(wid, hei, 32)
    _Dest Show2&
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), RGBPAL(ImageData(PixIndx&))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _Dest 0
    _PutImage , Show2&, BookArt&
    _FreeImage Show2&
    ArtIsLoaded% = -1
    If Not InTextMode% Then
        Screen BookArt&
        _ScreenShow
    End If
End Sub

Sub SwapScreens ()
    S_x& = ScX
    S_y& = ScY
    If InTextMode% Then
        If ArtIsLoaded% Then
            Rem _ScreenHide
            Screen BookArt&
            Rem _ScreenShow
            Rem _ScreenMove S_x&, S_y&
            InTextMode% = 0
        Else
            Exit Sub
        End If
    Else
        Rem _ScreenHide
        SETText
        SHOW_ControlBar
        Rem _ScreenShow
        Rem _ScreenMove S_x&, S_y&
    End If
End Sub

Function VeraPosition& (RealPos#)
    VERA_Ratio# = VERA_PlayLength# / MyAudio_PlayLength#
    VeraPosition = _Round(RealPos# * VERA_Ratio#)
End Function

Function RealPosition& (VeraPos#)
    REAL_Ratio# = MyAudio_PlayLength# / VERA_PlayLength#
    RealPosition = _Round(VeraPos# * REAL_Ratio#)
End Function


Sub LoadBMX (ImgFile$)
    Dim BmxHeader As BMXHeaderType
    BadFile = 0
    If Not _FileExists(ImgFile$) Then
        BadFile = -1
        Exit Sub
    End If

    BMXName$ = GetFileName(ImgFile$) + GetFileExt(ImgFile$)
    Open ImgFile$ For Binary As #1

    Get #1, , BmxHeader
    If BmxHeader.id <> "BMX" Then
        _MessageBox "Not a BMX File", BMXName$ + " NOT A BMX FILE", "error"
        Close 1
        BadFile = -1
        Exit Sub
    End If
    If BmxHeader.ver <> 1 Then
        _MessageBox "Version: " + Str$(BmxHeader.ver), BMXName$ + " NOT SUPPORTED", "error"
        BadFile = -1
        Close 1
        Exit Sub
    End If
    If BmxHeader.Bits <> 8 Then
        _MessageBox "Bit Depth: " + Str$(BmxHeader.Bits), BMXName$ + " NOT SUPPORTED", "error"
        BadFile = -1
        Close 1
        Exit Sub
    End If
    If BmxHeader.Compressed <> 0 Then
        _MessageBox "Compression", BMXName$ + " NOT SUPPORTED", "error"
        BadFile = -1
        Close 1
        Exit Sub
    End If
    wid = BmxHeader.Width
    hei = BmxHeader.Height
    ImageSize& = wid * hei
    ReDim ImageData(0 To (ImageSize& - 1)) As _Unsigned _Byte
    If BmxHeader.PalUsed = 0 Then
        used = 256
    Else
        used = BmxHeader.PalUsed
    End If
    PALSize = used * 2
    PalEnd = (BmxHeader.PalStart + used) - 1
    ReDim PALDATA(BmxHeader.PalStart To PalEnd) As VPALTYPE
    Get #1, , PALDATA()
    For I = BmxHeader.PalStart To PalEnd
        VERAPAL(I) = PALDATA(I)
        RGBPAL(I) = VERA2RGB(VERAPAL(I))
    Next I

    Get #1, , ImageData()
    Close #1
End Sub

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function


Function GetFileExt$ (FName$)
    DOT$ = "."
    L = Len(FName$)
    TMP$ = ""
    If InStr(1, FName$, DOT$) = 0 Then GoTo Skipall
    For I = L To 1 Step -1
        C$ = Mid$(FName$, I, 1)
        TMP$ = C$ + TMP$
        If C$ = DOT$ Then Exit For
    Next I
    Skipall:
    GetFileExt = TMP$
End Function

Function GetFileName$ (FName$)
    $If WINDOWS Then
        Slash$ = "\"
    $Else
        Slash$ = "/"
    $End If

    TMP$ = ""
    T$ = GetFileExt(FName$)
    CUT = Len(T$)
    L = Len(FName$)
    TName$ = Left$(FName$, L - CUT)
    If InStr(1, TName$, Slash$) = 0 Then
        TMP$ = TName$
        GoTo Skiploop
    End If
    For I = Len(TName$) To 1 Step -1
        C$ = Mid$(TName$, I, 1)
        If C$ <> Slash$ Then
            TMP$ = C$ + TMP$
        Else
            Exit For
        End If
    Next I
    Skiploop:
    GetFileName = TMP$
End Function

Function GetFilePath$ (FName$)
    t1$ = GetFileExt(FName$)
    t2$ = GetFileName(FName$)
    L = Len(FName$) - (Len(t1$) + Len(t2$))
    GetFilePath$ = Left$(FName$, L)
End Function

Function IsNum%% (PassedText As String)
    text$ = PassedText
    special$ = UCase$(Left$(text$, 2))
    Select Case special$
        Case "&H", "&B", "&O"
            'check for symbols on right side of value
            r3$ = Right$(text$, 3)
            Select Case r3$
                Case "~&&", "~%%", "~%&" 'unsigned int64, unsigned byte, unsigned offset
                    text$ = Left$(text$, Len(text$) - 3)
                Case Else
                    r2$ = Right$(text$, 2)
                    Select Case r2$
                        Case "~&", "##", "%&", "%%", "~%", "&&" 'unsigned long, float, offset, byte, unsigned integer, int64
                            text$ = Left$(text$, Len(text$) - 2)
                        Case Else
                            r$ = Right$(text$, 1)
                            Select Case r$
                                Case "&", "#", "%", "!" 'long, double, integer, single
                                    text$ = Left$(text$, Len(text$) - 1)
                            End Select
                    End Select
            End Select
            check$ = "0123456789ABCDEF"
            If special$ = "&O" Then check$ = "01234567"
            If special$ = "&B" Then check$ = "01"
            temp$ = Mid$(UCase$(text$), 2)
            For i = 1 To Len(temp$)
                If InStr(check$, Mid$(temp$, i, 1)) = 0 Then Exit For
            Next
            If i <= Len(temp$) Then IsNum = -1
        Case Else
            If _Trim$(Str$(Val(text$))) = text$ Then IsNum = -1
    End Select
End Function



